/*
 * -------------------------------------------------------------------
 * (c) 2001-2003 GIE SESAM-VITALE
 *
 * PROJET   : Services SESAM Vitale
 *
 * FICHIER  : ssv.h 
 *
 * Declaration des prototypes des fonctions SSV
 * -------------------------------------------------------------------
 */

#ifndef __SSV_H__
#define __SSV_H__

#ifdef __cplusplus
extern "C" {
#endif


/*
 * Inclusions
 */
#include <stddef.h>
/* Inclure le fichier de dclarations spcifiques systme :
   win32def.h, macosdef.h, aixdef.h, etc. */


/****** FONCTIONS STANDARDS *********/
						
typedef unsigned short (API_ENTRY FARPTR SSV_TraduireARL)
						 (short                   NbZDataIn,
                          void   FARPTR FARPTR    TZDataIn,
                          size_t FARPTR           TTailleZoneIn,
                          void FARPTR FARPTR		pZDataOut,
						  size_t FARPTR			pTailleZoneOut);

typedef unsigned short (API_ENTRY FARPTR SSV_LireCartePS)
                (const char FARPTR NomRessourcePS, 
                 const char FARPTR NomRessourceLecteur, 
                 const char FARPTR CodePorteurPS, 
                 void FARPTR FARPTR pZDataOut, 
                 size_t FARPTR pTailleZone);

typedef unsigned short (API_ENTRY FARPTR SSV_LireConfig)
				(void FARPTR FARPTR pZDataOut, 
				 size_t FARPTR psTailleDataOut);

typedef unsigned short (API_ENTRY FARPTR SSV_FormaterFactures)
						(char cFactureACreer,
						char cModeSecur,
						char cTypeFlux,
						void FARPTR pZDataIn,
						size_t TailleDataIn,
						void FARPTR FARPTR pZDataOut,
						size_t FARPTR pTailleZone);

typedef unsigned short (API_ENTRY FARPTR SSV_ChiffrerFacture)
						(void * pZDataIn,
						 size_t TailleDataIn, 
						 void * * pZDataOut, 
						 size_t * pTailleZone);

typedef unsigned short (API_ENTRY FARPTR SSV_SignerFactureVitale)
						(const char * pcNomRessourceVitale,
						 void * pZDataIn, 
						 size_t szTailleDataIn, 
						 void * * pZDataOut, 
						 size_t * pszTailleZone);

typedef unsigned short (API_ENTRY FARPTR SSV_CalculerHashFactureAssure)
						(const char * pcNumSerie,
						 void * pZDataIn, 
						 size_t szTailleDataIn, 
						 void * * pZDataOut, 
						 size_t * pszTailleZone);

typedef unsigned short (API_ENTRY FARPTR SSV_AjouterSignatureAssureDansFacture)
						(void * pZDataIn,
						 size_t szTailleDataIn, 
						 void * * pZDataOut, 
						 size_t * pszTailleZone);

typedef unsigned short (API_ENTRY FARPTR SSV_SignerFactureCPS)
						(const char * pcNomRessourcePS,
						const char * pcNomRessourceLecteur,
						const char * pcCodePorteurPS,
						char cNologSituation,
						void * pZDataIn,
						size_t szTailleDataIn,
						void * * pZDataOut,
						size_t * pszTailleZone);

typedef unsigned short (API_ENTRY SSV_CalculerHashFacturePS)
						(const char * pcNumSerieCPS,
						void * pZDataIn, 
						size_t usTailleDataIn, 
						void * * pZDataOut, 
						size_t * pusTailleZone);
						
typedef unsigned short (API_ENTRY SSV_AjouterSignaturePSFacture)
						(void * pZDataIn,
						size_t szTailleDataIn, 
						 void * * pZDataOut, 
						 size_t * pszTailleZone);

typedef unsigned short (API_ENTRY FARPTR SSV_SignerLotCPS)
						(const char * pcNomRessourcePS,
						const char * pcNomRessourceLecteur,
						const char * pcCodePorteurPS,
						char cNologSituation,
						void * pZDataIn,
						size_t szTailleDataIn,
						void * * pZDataOut,
						size_t * pszTailleZone);

typedef unsigned short (API_ENTRY FARPTR SSV_FormaterLot)
						(	short				NBZDataIn,
               				void FARPTR FARPTR	TZDataIn,
               				size_t	FARPTR		TTailleZoneIn,
			   				short FARPTR 		pNbZDataOut,
                			void FARPTR FARPTR	TZDataOut,
                			size_t	FARPTR		TTailleZoneOut);

typedef unsigned short (API_ENTRY FARPTR SSV_FormaterFichier)
						 (void FARPTR pZDataIn,size_t TailleDataIn,
						 void FARPTR FARPTR pZDataOut,size_t FARPTR pTailleZone);


typedef unsigned short  (API_ENTRY FARPTR SSV_InitTrace)
						(char FARPTR pathConf, char FARPTR ModeOuverture,
						 unsigned short Module, unsigned char Niveau);
						  

typedef unsigned short  (API_ENTRY FARPTR SSV_AllouerZoneMem)
						(void FARPTR FARPTR pZDataIn,
						 size_t taille);
						     
typedef void (API_ENTRY FARPTR SSV_LibererZoneMem)
						(void FARPTR pZone);

typedef unsigned short  (API_ENTRY FARPTR SSV_MajDateLecteur)
						(const char FARPTR pcNomRessourceLecteur,
						 const char FARPTR pcDateHeure);

typedef unsigned short  (API_ENTRY FARPTR SSV_LireDateLecteur)
						(const char FARPTR pcNomRessourceLecteur,
						 char FARPTR pcDateHeure);


typedef unsigned short (API_ENTRY FARPTR SSV_LireDroitsVitale)
                (const char FARPTR NomRessourcePS, 
                 const char FARPTR NomRessourceLecteur, 
                 const char FARPTR CodePorteurPS, 
                 const char FARPTR DateConsultation, 
                 void FARPTR FARPTR pZDataOut, 
                 size_t FARPTR pTailleZone);


typedef unsigned short  (API_ENTRY FARPTR SSV_IdentifierTLA)
						(const char FARPTR pcNomRessourceLecteur, 
						 const char FARPTR NumVersionCDC,
	    				 void FARPTR FARPTR pZDataOut, 
	    				 size_t FARPTR tailleDataOut);

typedef unsigned short (API_ENTRY FARPTR SSV_DechargerFacturesPdT)
						(	const char FARPTR	NomRessourcePS,
              			 	const char FARPTR	NomRessourceLecteur,
               				const char FARPTR	CodePorteurPS,
               				const char FARPTR	pcNumFact,
							short sNbZDataIn,
						    void FARPTR FARPTR pvTZDataIn, 
						    size_t FARPTR psTTailleDataIn,
			   				short FARPTR 		pNbZDataOut,
                			void FARPTR FARPTR	TZDataOut,
                			size_t	FARPTR		TTailleZoneOut);

typedef unsigned short (API_ENTRY FARPTR SSV_DechargerFSETLA)
						(	const char FARPTR	NomRessourcePS,
              			 	const char FARPTR	NomRessourceLecteur,
               				const char FARPTR	CodePorteurPS,
               				const char FARPTR	pcNumFact,
			   				short FARPTR 		pNbZDataOut,
                			void FARPTR FARPTR	TZDataOut,
                			size_t	FARPTR		TTailleZoneOut);

typedef unsigned short (API_ENTRY FARPTR SSV_DechargerFSETLANC)
						(	const char FARPTR	NomRessourcePS,
              			 	const char FARPTR	NomRessourceLecteur,
               				const char FARPTR	CodePorteurPS,
               				const char FARPTR	pcNumFact,
			   				short FARPTR 		pNbZDataOut,
                			void FARPTR FARPTR	TZDataOut,
                			size_t	FARPTR		TTailleZoneOut);
typedef unsigned short (API_ENTRY FARPTR SSV_EffacerTLA)
					(const char FARPTR NomRessourcePS,
					 const char FARPTR NomRessourceLecteur,
					 const char FARPTR CodePorteurPS, 	
					 const char FARPTR cNumFacturation,
					 const char FARPTR cTypeDonnee);

typedef unsigned short (API_ENTRY FARPTR SSV_ChargerFacturesPdT)
						(const char FARPTR pcNomRessourceLecteur,
						const char FARPTR pcNumFacturation, 
						short sNbZDataIn,
						void FARPTR FARPTR pvTZDataIn, 
						size_t FARPTR psTTailleDataIn,
						short FARPTR 		pNbZDataOut,
                		void FARPTR FARPTR	TZDataOut,
                		size_t	FARPTR		TTailleZoneOut); 

typedef unsigned short (API_ENTRY FARPTR SSV_ChargerAppli)
						(const char FARPTR pcNomRessourceLecteur, 
						short sNbZDataIn,
						void FARPTR FARPTR pvTZDataIn, 
						size_t FARPTR psTTailleDataIn);

typedef unsigned short (API_ENTRY FARPTR SSV_ChargerDonneesTLA)
						(const char FARPTR pcNomRessourceLecteur, 
						short sNbZDataIn,
						void FARPTR FARPTR pvTZDataIn, 
						size_t FARPTR psTTailleDataIn);

typedef unsigned short (API_ENTRY FARPTR SSV_DechargerBeneficiaires)                 
                 (const char FARPTR   NomRessourcePS,
		          const char FARPTR	  NomRessourceLecteur,
		          const char FARPTR	  CodePorteurPS,
		          const char FARPTR	  cNumFacturation,
				  short FARPTR		  sNbZDataOut, 
				  void FARPTR FARPTR  pTZDataOut, 
				  size_t FARPTR		  sTTailleDataOut);

typedef unsigned short (API_ENTRY FARPTR SSV_TraduireFSE)
				 (void FARPTR pZDataIn,
				  size_t TailleDataIn,
				  void FARPTR FARPTR pZDataOut,
				  size_t FARPTR pTailleZone);

typedef unsigned short (API_ENTRY FARPTR SSV_SecuriserFacture)
                 (const char FARPTR pcNomRessourcePS,
				  const char FARPTR pcNomRessourceLecteur,
				  const char FARPTR pcCodePorteurPS, 
				  char cNologSituation,
				  const char FARPTR  pcNumFact,
				  void FARPTR pvDataIn,
				  size_t       szTailleDataIn ,
				  void FARPTR FARPTR pvDataOut, 
				  size_t FARPTR pszTailleDataOut);

typedef unsigned short (API_ENTRY FARPTR SSV_InitLIB2) (const char FARPTR pcFichierSesam);

typedef unsigned short (API_ENTRY FARPTR SSV_TermLIB)();



/****** FONCTIONS SIMPLIFIEES *********/

typedef unsigned short (API_ENTRY FARPTR SIS_TraduireARL)
						 (unsigned short numeroSession);

typedef unsigned short (API_ENTRY FARPTR SIS_LireCartePS)
                (const char FARPTR NomRessourcePS, 
                 const char FARPTR NomRessourceLecteur, 
                 const char FARPTR CodePorteurPS,
                 unsigned short numeroSession);

typedef unsigned short (API_ENTRY FARPTR SIS_LireConfig)
				(unsigned short numeroSession);


typedef unsigned short (API_ENTRY FARPTR SIS_FormaterFactures)
						(char cFacturesACreer,
						char ModeSecur,
						char cTypeFlux,
                        unsigned short numeroSession);

typedef unsigned short (API_ENTRY FARPTR SIS_ChiffrerFacture)
						(unsigned short numeroSession);

typedef unsigned short (API_ENTRY FARPTR SIS_SignerFactureVitale)
						(const char * pcNomRessourceVitale,
						 unsigned short numeroSession);

typedef unsigned short (API_ENTRY FARPTR SIS_CalculerHashFactureAssure)
						(const char * pcNumSerie,
						 unsigned short numeroSession);

typedef unsigned short (API_ENTRY FARPTR SIS_AjouterSignatureAssureDansFacture)
						(unsigned short numeroSession);

typedef unsigned short (API_ENTRY FARPTR SIS_SignerFactureCPS)
						(const char * pcNomRessourcePS,
						 const char * pcNomRessourceLecteur,
						 const char * pcCodePorteurPS,
						 char cNologSituation,
						 unsigned short numeroSession);

typedef unsigned short (SIS_CalculerHashFacturePS)
						(const char * pcNumSerieCPS,
						unsigned short numeroSession);

typedef unsigned short (API_ENTRY SIS_AjouterSignaturePSFacture)
						(unsigned short numeroSession);

typedef unsigned short (API_ENTRY FARPTR SIS_SignerLotCPS)
						(const char * pcNomRessourcePS,
						 const char * pcNomRessourceLecteur,
						 const char * pcCodePorteurPS,
						 char cNologSituation,
						 unsigned short numeroSession);

typedef unsigned short (API_ENTRY FARPTR SIS_FormaterLot)
						(unsigned short numeroSession);

typedef unsigned short (API_ENTRY FARPTR SIS_FormaterFichier)
						 (unsigned short numeroSession);

typedef unsigned short  (API_ENTRY FARPTR SIS_InitTrace)
						(char FARPTR NomFichier, char FARPTR ModeOuverture,
						 unsigned short Module, unsigned char Niveau);
						  

typedef unsigned short  (API_ENTRY FARPTR SIS_MajDateLecteur)
						(const char FARPTR pcNomRessourceLecteur,
						 const char FARPTR pcDateHeure);

typedef unsigned short  (API_ENTRY FARPTR SIS_LireDateLecteur)
						(const char FARPTR pcNomRessourceLecteur,
						 char FARPTR pcDateHeure);


typedef unsigned short (API_ENTRY FARPTR SIS_LireDroitsVitale)
                (const char FARPTR NomRessourcePS, 
                 const char FARPTR NomRessourceLecteur, 
                 const char FARPTR CodePorteurPS, 
                 const char FARPTR DateConsultation,
                 unsigned short numeroSession); 

typedef unsigned short  (API_ENTRY FARPTR SIS_IdentifierTLA)
						(const char FARPTR pcNomRessourceLecteur, 
						 const char FARPTR NumVersionCDC,
                         unsigned short numeroSession );

typedef unsigned short (API_ENTRY FARPTR SIS_DechargerFacturesPdT)
						( const char FARPTR	NomRessourcePS,
              			 	const char FARPTR	NomRessourceLecteur,
               				const char FARPTR	CodePorteurPS,
               				const char FARPTR	pcNumFact,
                                         unsigned short numeroSession);

typedef unsigned short (API_ENTRY FARPTR SIS_DechargerFSETLA)
						(const char FARPTR	NomRessourcePS,
              			 	const char FARPTR	NomRessourceLecteur,
               				const char FARPTR	CodePorteurPS,
               				const char FARPTR	pcNumFact,
                                        unsigned short numeroSession);

typedef unsigned short (API_ENTRY FARPTR SIS_DechargerFSETLANC)
						(const char FARPTR	NomRessourcePS,
              			 	const char FARPTR	NomRessourceLecteur,
               				const char FARPTR	CodePorteurPS,
               				const char FARPTR	pcNumFact,
                                        unsigned short numeroSession);
typedef unsigned short (API_ENTRY FARPTR SIS_EffacerTLA)
					(const char FARPTR NomRessourcePS,
					 const char FARPTR NomRessourceLecteur,
					 const char FARPTR CodePorteurPS, 	
					 const char FARPTR cNumFacturation,
					 const char FARPTR cTypeDonnee);

typedef unsigned short (API_ENTRY FARPTR SIS_ChargerFacturesPdT)
						(const char FARPTR pcNomRessourceLecteur,
						 const char FARPTR pcNumFacturation,
                                                 unsigned short numeroSession); 

typedef unsigned short (API_ENTRY FARPTR SIS_ChargerAppli)
						(const char FARPTR pcNomRessourceLecteur,
                                                  unsigned short numeroSession);

typedef unsigned short (API_ENTRY FARPTR SIS_ChargerDonneesTLA)
						(const char FARPTR pcNomRessourceLecteur,
                                                unsigned short numeroSession);

typedef unsigned short (API_ENTRY FARPTR SIS_DechargerBeneficiaires)                 
                 (	  const char FARPTR   NomRessourcePS,
		          const char FARPTR	  NomRessourceLecteur,
		          const char FARPTR	  CodePorteurPS,
		          const char FARPTR	  cNumFacturation,
                          unsigned short numeroSession);

typedef unsigned short (API_ENTRY FARPTR SIS_TraduireFSE)
				 (unsigned short numeroSession);

typedef unsigned short (API_ENTRY FARPTR SIS_SecuriserFacture)
                 ( const char FARPTR pcNomRessourcePS,
				  const char FARPTR pcNomRessourceLecteur,
				  const char FARPTR pcCodePorteurPS, 
				  char cNologSituation,
				  const char FARPTR  pcNumFact,
                                  unsigned short numeroSession);
						  

/* inclusion temporaire dans ssv.h pour ne pas a avoir  relivrer Sedica (pas d'incidence sur le code) ->  inclure dans sedica.h ou commun.h*/
/* Chaine discriminante d un nom de ressource TL PCSC */
#define TL_PCSC " TL "


#ifdef __cplusplus
}
#endif

#endif
